#!/usr/bin/perl -w
#
# instanceGenerator.pl
#
# Martin Brain
# mjb@cs.bath.ac.uk
# 27/02/09
#
# A solitaire instance generator
#
# Marcello Balduccini
# marcello.balduccini@gmail.com
# Jan 11, 2011
# Modified to comply with the requirements of ASPCOMP2011.
#

use strict;
use warnings;

use Getopt::Long;

my $time;
my $density;

my $i;
my $j;

# Default values
$time = 4;
$density = 0;

Getopt::Long::GetOptions("time=i" => \$time,
			 "density=f" => \$density);

# Check values
if ($time < 1) {
  die("Time must be strictly positive.");
}
if (($density < 0) || ($density > 1)) {
  die("Density must be in the range [0,1]");
}

# Generate the program
for ($i = 1; $i <= $time; ++$i) {
  print "time($i).\n";
}
for ($i = 1; $i <= 7; ++$i) {
  for ($j = 1; $j <= 7; ++$j) {
    if ((($i >= 3) && ($i <= 5)) || (($j >= 3) && ($j <= 5))) {
      if (rand() < $density) {
	print "empty($j,$i).\n";
      } else {
	print "full($j,$i).\n";
      }
    }
  }
}
